// CircleToy.cpp
// A good tutorial application for the beginner.
// You may use this source code in any way you see fit.  It is in the
// public domain.
// Michael D. Crawford crawford@goingware.com
// GoingWare - Expert Software Development and Consulting
// http://www.goingware.com

#include <Application.h>
#include <Window.h>
#include <View.h>

class CircleApp: public BApplication{
	public:
		CircleApp();
		virtual ~CircleApp();
};

class CircleWindow: public BWindow{
	public:
		CircleWindow();
		virtual ~CircleWindow();
		virtual bool QuitRequested();
};

class CircleView: public BView{
	public:
		CircleView( BRect frame );
		virtual ~CircleView();		
		virtual void Draw( BRect updateRect );
};

int main( int argc, char **argv )
{
	BApplication *myApp = new CircleApp;
	
	myApp->Run();
	
	delete myApp;
	
	return 0;
} 

CircleApp::CircleApp()
	: BApplication( "application/x-circledraw" )
{
	BWindow *myWindow = new CircleWindow;
	myWindow->Show();
	
	return;
}

CircleApp::~CircleApp()
{
	return;
}

CircleWindow::CircleWindow()
	: BWindow( BRect( 100, 100, 300, 300 ),
										"Circles",
										B_DOCUMENT_WINDOW,
										0 )
{
	BView *myView = new CircleView( Bounds() );
	
	AddChild( myView );
	
	return;
}

CircleWindow::~CircleWindow()
{
	return;
}

bool CircleWindow::QuitRequested()
{
	be_app->PostMessage( B_QUIT_REQUESTED );
	
	return true;
}

CircleView::CircleView( BRect frame )
	: BView( frame, "CircleView", B_NOT_RESIZABLE, B_WILL_DRAW )
{
	return;
}

CircleView::~CircleView()
{
	return;
}

void CircleView::Draw( BRect updateRect )
{
	BRect frame = Bounds();
	frame.top += 10;
	frame.left += 10;
	frame.bottom -= 10;
	frame.right -= 10;
	
	StrokeEllipse( frame );
	return;
}
